// Code generated by mockery v2.42.3. DO NOT EDIT.

package mock_repository

import (
	context "context"

	metadata "gitlab.com/commonground/nlx/fsc-nlx/txlog-api/domain/metadata"

	mock "github.com/stretchr/testify/mock"

	record "gitlab.com/commonground/nlx/fsc-nlx/txlog-api/domain/record"

	uuid "github.com/gofrs/uuid"
)

// MockRepository is an autogenerated mock type for the Repository type
type MockRepository struct {
	mock.Mock
}

type MockRepository_Expecter struct {
	mock *mock.Mock
}

func (_m *MockRepository) EXPECT() *MockRepository_Expecter {
	return &MockRepository_Expecter{mock: &_m.Mock}
}

// CreateMetadataRecords provides a mock function with given fields: _a0, _a1
func (_m *MockRepository) CreateMetadataRecords(_a0 context.Context, _a1 []*metadata.Record) error {
	ret := _m.Called(_a0, _a1)

	if len(ret) == 0 {
		panic("no return value specified for CreateMetadataRecords")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, []*metadata.Record) error); ok {
		r0 = rf(_a0, _a1)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockRepository_CreateMetadataRecords_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'CreateMetadataRecords'
type MockRepository_CreateMetadataRecords_Call struct {
	*mock.Call
}

// CreateMetadataRecords is a helper method to define mock.On call
//   - _a0 context.Context
//   - _a1 []*metadata.Record
func (_e *MockRepository_Expecter) CreateMetadataRecords(_a0 interface{}, _a1 interface{}) *MockRepository_CreateMetadataRecords_Call {
	return &MockRepository_CreateMetadataRecords_Call{Call: _e.mock.On("CreateMetadataRecords", _a0, _a1)}
}

func (_c *MockRepository_CreateMetadataRecords_Call) Run(run func(_a0 context.Context, _a1 []*metadata.Record)) *MockRepository_CreateMetadataRecords_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].([]*metadata.Record))
	})
	return _c
}

func (_c *MockRepository_CreateMetadataRecords_Call) Return(_a0 error) *MockRepository_CreateMetadataRecords_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockRepository_CreateMetadataRecords_Call) RunAndReturn(run func(context.Context, []*metadata.Record) error) *MockRepository_CreateMetadataRecords_Call {
	_c.Call.Return(run)
	return _c
}

// CreateRecords provides a mock function with given fields: _a0, _a1
func (_m *MockRepository) CreateRecords(_a0 context.Context, _a1 []*record.Record) error {
	ret := _m.Called(_a0, _a1)

	if len(ret) == 0 {
		panic("no return value specified for CreateRecords")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, []*record.Record) error); ok {
		r0 = rf(_a0, _a1)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockRepository_CreateRecords_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'CreateRecords'
type MockRepository_CreateRecords_Call struct {
	*mock.Call
}

// CreateRecords is a helper method to define mock.On call
//   - _a0 context.Context
//   - _a1 []*record.Record
func (_e *MockRepository_Expecter) CreateRecords(_a0 interface{}, _a1 interface{}) *MockRepository_CreateRecords_Call {
	return &MockRepository_CreateRecords_Call{Call: _e.mock.On("CreateRecords", _a0, _a1)}
}

func (_c *MockRepository_CreateRecords_Call) Run(run func(_a0 context.Context, _a1 []*record.Record)) *MockRepository_CreateRecords_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].([]*record.Record))
	})
	return _c
}

func (_c *MockRepository_CreateRecords_Call) Return(_a0 error) *MockRepository_CreateRecords_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockRepository_CreateRecords_Call) RunAndReturn(run func(context.Context, []*record.Record) error) *MockRepository_CreateRecords_Call {
	_c.Call.Return(run)
	return _c
}

// ListMetadataRecords provides a mock function with given fields: _a0, _a1
func (_m *MockRepository) ListMetadataRecords(_a0 context.Context, _a1 uuid.UUID) ([]*metadata.Record, error) {
	ret := _m.Called(_a0, _a1)

	if len(ret) == 0 {
		panic("no return value specified for ListMetadataRecords")
	}

	var r0 []*metadata.Record
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, uuid.UUID) ([]*metadata.Record, error)); ok {
		return rf(_a0, _a1)
	}
	if rf, ok := ret.Get(0).(func(context.Context, uuid.UUID) []*metadata.Record); ok {
		r0 = rf(_a0, _a1)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*metadata.Record)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, uuid.UUID) error); ok {
		r1 = rf(_a0, _a1)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockRepository_ListMetadataRecords_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ListMetadataRecords'
type MockRepository_ListMetadataRecords_Call struct {
	*mock.Call
}

// ListMetadataRecords is a helper method to define mock.On call
//   - _a0 context.Context
//   - _a1 uuid.UUID
func (_e *MockRepository_Expecter) ListMetadataRecords(_a0 interface{}, _a1 interface{}) *MockRepository_ListMetadataRecords_Call {
	return &MockRepository_ListMetadataRecords_Call{Call: _e.mock.On("ListMetadataRecords", _a0, _a1)}
}

func (_c *MockRepository_ListMetadataRecords_Call) Run(run func(_a0 context.Context, _a1 uuid.UUID)) *MockRepository_ListMetadataRecords_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(uuid.UUID))
	})
	return _c
}

func (_c *MockRepository_ListMetadataRecords_Call) Return(_a0 []*metadata.Record, _a1 error) *MockRepository_ListMetadataRecords_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockRepository_ListMetadataRecords_Call) RunAndReturn(run func(context.Context, uuid.UUID) ([]*metadata.Record, error)) *MockRepository_ListMetadataRecords_Call {
	_c.Call.Return(run)
	return _c
}

// ListRecords provides a mock function with given fields: ctx, req
func (_m *MockRepository) ListRecords(ctx context.Context, req *record.ListRecordsRequest) ([]*record.Record, error) {
	ret := _m.Called(ctx, req)

	if len(ret) == 0 {
		panic("no return value specified for ListRecords")
	}

	var r0 []*record.Record
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *record.ListRecordsRequest) ([]*record.Record, error)); ok {
		return rf(ctx, req)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *record.ListRecordsRequest) []*record.Record); ok {
		r0 = rf(ctx, req)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*record.Record)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *record.ListRecordsRequest) error); ok {
		r1 = rf(ctx, req)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockRepository_ListRecords_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ListRecords'
type MockRepository_ListRecords_Call struct {
	*mock.Call
}

// ListRecords is a helper method to define mock.On call
//   - ctx context.Context
//   - req *record.ListRecordsRequest
func (_e *MockRepository_Expecter) ListRecords(ctx interface{}, req interface{}) *MockRepository_ListRecords_Call {
	return &MockRepository_ListRecords_Call{Call: _e.mock.On("ListRecords", ctx, req)}
}

func (_c *MockRepository_ListRecords_Call) Run(run func(ctx context.Context, req *record.ListRecordsRequest)) *MockRepository_ListRecords_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(*record.ListRecordsRequest))
	})
	return _c
}

func (_c *MockRepository_ListRecords_Call) Return(_a0 []*record.Record, _a1 error) *MockRepository_ListRecords_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockRepository_ListRecords_Call) RunAndReturn(run func(context.Context, *record.ListRecordsRequest) ([]*record.Record, error)) *MockRepository_ListRecords_Call {
	_c.Call.Return(run)
	return _c
}

// Ping provides a mock function with given fields: ctx
func (_m *MockRepository) Ping(ctx context.Context) error {
	ret := _m.Called(ctx)

	if len(ret) == 0 {
		panic("no return value specified for Ping")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context) error); ok {
		r0 = rf(ctx)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockRepository_Ping_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Ping'
type MockRepository_Ping_Call struct {
	*mock.Call
}

// Ping is a helper method to define mock.On call
//   - ctx context.Context
func (_e *MockRepository_Expecter) Ping(ctx interface{}) *MockRepository_Ping_Call {
	return &MockRepository_Ping_Call{Call: _e.mock.On("Ping", ctx)}
}

func (_c *MockRepository_Ping_Call) Run(run func(ctx context.Context)) *MockRepository_Ping_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context))
	})
	return _c
}

func (_c *MockRepository_Ping_Call) Return(_a0 error) *MockRepository_Ping_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockRepository_Ping_Call) RunAndReturn(run func(context.Context) error) *MockRepository_Ping_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockRepository creates a new instance of MockRepository. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockRepository(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockRepository {
	mock := &MockRepository{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
